// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{ffi, Artifact, Context, Issue, ReleaseKind, ReleaseUrlKind, UrgencyKind};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "AsRelease")]
    pub struct Release(Object<ffi::AsRelease, ffi::AsReleaseClass>);

    match fn {
        type_ => || ffi::as_release_get_type(),
    }
}

impl Release {
    pub const NONE: Option<&'static Release> = None;

    #[doc(alias = "as_release_new")]
    pub fn new() -> Release {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::as_release_new()) }
    }
}

impl Default for Release {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Release>> Sealed for T {}
}

pub trait ReleaseExt: IsA<Release> + sealed::Sealed + 'static {
    #[doc(alias = "as_release_add_artifact")]
    fn add_artifact(&self, artifact: &impl IsA<Artifact>) {
        unsafe {
            ffi::as_release_add_artifact(
                self.as_ref().to_glib_none().0,
                artifact.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "as_release_add_issue")]
    fn add_issue(&self, issue: &impl IsA<Issue>) {
        unsafe {
            ffi::as_release_add_issue(
                self.as_ref().to_glib_none().0,
                issue.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "as_release_add_tag")]
    fn add_tag(&self, ns: &str, tag: &str) -> bool {
        unsafe {
            from_glib(ffi::as_release_add_tag(
                self.as_ref().to_glib_none().0,
                ns.to_glib_none().0,
                tag.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_release_clear_tags")]
    fn clear_tags(&self) {
        unsafe {
            ffi::as_release_clear_tags(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "as_release_get_artifacts")]
    #[doc(alias = "get_artifacts")]
    fn artifacts(&self) -> Vec<Artifact> {
        unsafe {
            FromGlibPtrContainer::from_glib_none(ffi::as_release_get_artifacts(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_release_get_context")]
    #[doc(alias = "get_context")]
    fn context(&self) -> Option<Context> {
        unsafe { from_glib_none(ffi::as_release_get_context(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_release_get_date")]
    #[doc(alias = "get_date")]
    fn date(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::as_release_get_date(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_release_get_date_eol")]
    #[doc(alias = "get_date_eol")]
    fn date_eol(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::as_release_get_date_eol(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_release_get_description")]
    #[doc(alias = "get_description")]
    fn description(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::as_release_get_description(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_release_get_issues")]
    #[doc(alias = "get_issues")]
    fn issues(&self) -> Vec<Issue> {
        unsafe {
            FromGlibPtrContainer::from_glib_none(ffi::as_release_get_issues(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_release_get_kind")]
    #[doc(alias = "get_kind")]
    fn kind(&self) -> ReleaseKind {
        unsafe { from_glib(ffi::as_release_get_kind(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_release_get_timestamp")]
    #[doc(alias = "get_timestamp")]
    fn timestamp(&self) -> u64 {
        unsafe { ffi::as_release_get_timestamp(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "as_release_get_timestamp_eol")]
    #[doc(alias = "get_timestamp_eol")]
    fn timestamp_eol(&self) -> u64 {
        unsafe { ffi::as_release_get_timestamp_eol(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "as_release_get_urgency")]
    #[doc(alias = "get_urgency")]
    fn urgency(&self) -> UrgencyKind {
        unsafe { from_glib(ffi::as_release_get_urgency(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_release_get_url")]
    #[doc(alias = "get_url")]
    fn url(&self, url_kind: ReleaseUrlKind) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::as_release_get_url(
                self.as_ref().to_glib_none().0,
                url_kind.into_glib(),
            ))
        }
    }

    #[doc(alias = "as_release_get_version")]
    #[doc(alias = "get_version")]
    fn version(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::as_release_get_version(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_release_has_tag")]
    fn has_tag(&self, ns: &str, tag: &str) -> bool {
        unsafe {
            from_glib(ffi::as_release_has_tag(
                self.as_ref().to_glib_none().0,
                ns.to_glib_none().0,
                tag.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_release_remove_tag")]
    fn remove_tag(&self, ns: &str, tag: &str) -> bool {
        unsafe {
            from_glib(ffi::as_release_remove_tag(
                self.as_ref().to_glib_none().0,
                ns.to_glib_none().0,
                tag.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "as_release_set_context")]
    fn set_context(&self, context: &impl IsA<Context>) {
        unsafe {
            ffi::as_release_set_context(
                self.as_ref().to_glib_none().0,
                context.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "as_release_set_date")]
    fn set_date(&self, date: &str) {
        unsafe {
            ffi::as_release_set_date(self.as_ref().to_glib_none().0, date.to_glib_none().0);
        }
    }

    #[doc(alias = "as_release_set_date_eol")]
    fn set_date_eol(&self, date: &str) {
        unsafe {
            ffi::as_release_set_date_eol(self.as_ref().to_glib_none().0, date.to_glib_none().0);
        }
    }

    #[doc(alias = "as_release_set_description")]
    fn set_description(&self, description: &str, locale: Option<&str>) {
        unsafe {
            ffi::as_release_set_description(
                self.as_ref().to_glib_none().0,
                description.to_glib_none().0,
                locale.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "as_release_set_kind")]
    fn set_kind(&self, kind: ReleaseKind) {
        unsafe {
            ffi::as_release_set_kind(self.as_ref().to_glib_none().0, kind.into_glib());
        }
    }

    #[doc(alias = "as_release_set_timestamp")]
    fn set_timestamp(&self, timestamp: u64) {
        unsafe {
            ffi::as_release_set_timestamp(self.as_ref().to_glib_none().0, timestamp);
        }
    }

    #[doc(alias = "as_release_set_timestamp_eol")]
    fn set_timestamp_eol(&self, timestamp: u64) {
        unsafe {
            ffi::as_release_set_timestamp_eol(self.as_ref().to_glib_none().0, timestamp);
        }
    }

    #[doc(alias = "as_release_set_urgency")]
    fn set_urgency(&self, urgency: UrgencyKind) {
        unsafe {
            ffi::as_release_set_urgency(self.as_ref().to_glib_none().0, urgency.into_glib());
        }
    }

    #[doc(alias = "as_release_set_url")]
    fn set_url(&self, url_kind: ReleaseUrlKind, url: &str) {
        unsafe {
            ffi::as_release_set_url(
                self.as_ref().to_glib_none().0,
                url_kind.into_glib(),
                url.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "as_release_set_version")]
    fn set_version(&self, version: &str) {
        unsafe {
            ffi::as_release_set_version(self.as_ref().to_glib_none().0, version.to_glib_none().0);
        }
    }

    #[doc(alias = "as_release_vercmp")]
    fn vercmp(&self, rel2: &impl IsA<Release>) -> i32 {
        unsafe {
            ffi::as_release_vercmp(
                self.as_ref().to_glib_none().0,
                rel2.as_ref().to_glib_none().0,
            )
        }
    }
}

impl<O: IsA<Release>> ReleaseExt for O {}
